/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PGER                                                     */
/* Tabela : PARAMGERAL                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PGER'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PGER
GO

CREATE TRIGGER DTULTATU_PGER
ON PARAMGERAL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PARAMGERAL', null,'CDPARGERAL=' + CDPARGERAL + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PARAMGERAL
      SET DTULTATUPGER = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(PARAMGERAL.CDPARGERAL,0)   = ISNULL(INSERTED.CDPARGERAL,0));
   END;
END;
GO


UPDATE PARAMGERAL SET DTULTATUPGER = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPGER IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPGER' and
            type = 'D')
   ALTER TABLE PARAMGERAL DROP CONSTRAINT DEFAULT_DTULTATUPGER
GO

ALTER TABLE PARAMGERAL ADD CONSTRAINT DEFAULT_DTULTATUPGER
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPGER
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PGER','5.70.xxx';
GO

